--this lua script for use in conky
require 'cairo'
extents=cairo_text_extents_t:create()
tolua.takeownership(extents)
function conky_clock()
if conky_window == nil then return end
local cs = cairo_xlib_surface_create(conky_window.display, conky_window.drawable, conky_window.visual, conky_window.width, conky_window.height)
cr = cairo_create(cs)
local updates=tonumber(conky_parse('${updates}'))
if updates>5 then
--######################################################################
-- Settings ############################################################
--######################################################################
center_x=110
center_y=110
--style set 0 for none or 1, 2, 3, 4, or mine
style_set=1
--clock face 1 or 2
clock_face=2
--hours on the clock 12 or 24
hours=12
--visiblity 1 or 0
hands=1
lights=0
digital=0
chrono=0
gears=0
texts=1
--the second interval displayed 5, 10, or 15
seconds=15
-- Colors
d_font_red=.8
d_font_green=.8
d_font_blue=.8
d_font_alpha=1
br_red=.5
br_green=.5
br_blue=.5
br_alpha=1
bg_red=.05
bg_green=.05
bg_blue=.05
bg_alpha=1
lights_red=.2
lights_green=.2
lights_blue=1
lights_alpha=.75
hands_red=.5
hands_green=.5
hands_blue=.5
hands_ired=.25
hands_igreen=.25
hands_iblue=.25
hands_alpha=1
--######################################################################
-- Style Sets ##########################################################
--######################################################################
if style_set == 1 then
clock_face=1
hours=12
hands=0
lights=1
digital=1
chrono=0
gears=0
texts=1
seconds=5
end
if style_set == 2 then
clock_face=2
hours=12
hands=1
lights=0
digital=0
chrono=0
gears=0
texts=1
seconds=5
end
if style_set == 3 then
clock_face=1
hours=24
hands=0
lights=1
digital=0
chrono=1
gears=1
texts=1
seconds=10
end
if style_set == 4 then
clock_face=2
hours=24
hands=1
lights=0
digital=0
chrono=1
gears=1
texts=1
seconds=10
end
if style_set == mine then
clock_face=2
hours=24
hands=1
lights=1
digital=0
chrono=1
gears=1
texts=1
seconds=5
end
--######################################################################
-- Strings #############################################################
--######################################################################
d_line_width=1
d_math=math.pi/180
d_font="mono"
d_font_size=11
d_font_slant=CAIRO_FONT_SLANT_NORMAL
d_font_face=CAIRO_FONT_WEIGHT_NORMAL
outer_radius=100
year=conky_parse("${time %y}")
month_number=tonumber(conky_parse("${time %m}"))
weekday=conky_parse("${time %u}")
day=conky_parse("${time %a}")
abbr_month=conky_parse("${time %b}")
day_number=conky_parse("${time %d}")
ampm=conky_parse("${time %p}")
second=tonumber(conky_parse("${time %S}"))
minute=tonumber(conky_parse("${time %M}"))
if hours ~= 12 then hours=24 end
if hours == 12 then
hour=tonumber(conky_parse("${time %I}"))
time_hms=conky_parse("${time %r}")
i_start=1
i_end=12
else
hour=tonumber(conky_parse("${time %H}"))
time_hms=conky_parse("${time %T}")
i_start=0
i_end=hours-1
end
--######################################################################
-- Gears ###############################################################
--######################################################################
if gears == 1 then
gear((center_x+45),(center_y+45),25,25,6,second,60,1,.75)
gear((center_x-45),(center_y+45),25,20,6,((minute*60)+second),(60*60),0,.75)
gear((center_x+45),(center_y-45),25,15,6,((hour*60)+(minute*60)+second),(60*60*60),1,.75)
gear((center_x-45),(center_y-45),25,10,6,((day_number*24)+(hour*60)+(minute*60)+second),(60*60*60*24),1,.75)
end
--######################################################################
-- Chrono ##############################################################
--######################################################################
if chrono == 1 then
--left weekday
cairo_set_line_width(cr,2)
cairo_arc(cr,(center_x-35),center_y,25,(0*d_math),(360*d_math))
cairo_arc_negative(cr,(center_x-35),center_y,12,(360*d_math),(0*d_math))
cairo_set_source_rgba(cr,bg_red,bg_green,bg_blue,bg_alpha)
cairo_fill(cr)
cairo_set_line_width(cr,2)
cairo_arc(cr,(center_x-35),center_y,25,(0*d_math),(360*d_math))
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_stroke(cr)
cairo_set_line_width(cr,2)
cairo_arc(cr,(center_x-35),center_y,12,(0*d_math),(360*d_math))
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_stroke(cr)
cairo_set_source_rgba(cr,d_font_red,d_font_green,d_font_blue,d_font_alpha)
--######################################################################
-- mrpeacy code ########################################################
--######################################################################
for i=1,7 do
weekdays={"S","M","T","W","T","F","S"}
	x,y=pt((center_x-35),center_y,18.5,((360/7)*(i-1)))
	text({y=y,x=x,t=(weekdays[i]),hj="c",vj="m"})
end--for
--######################################################################
-- mrpeacy code ########################################################
--######################################################################
cairo_stroke(cr)
weekday_position=(-90*d_math)+(((360/7)*weekday)*d_math)
cairo_set_line_width(cr,2)
cairo_move_to(cr,(center_x-35),center_y)
cairo_arc(cr,(center_x-35),center_y,20,weekday_position,weekday_position)
cairo_set_source_rgba(cr,.75,.75,.75,1)
cairo_stroke(cr)
--up month day
cairo_set_line_width(cr,2)
cairo_arc(cr,center_x,(center_y-35),25,(0*d_math),(360*d_math))
cairo_arc_negative(cr,center_x,(center_y-35),12,(360*d_math),(0*d_math))
cairo_set_source_rgba(cr,bg_red,bg_green,bg_blue,bg_alpha)
cairo_fill(cr)
cairo_set_line_width(cr,2)
cairo_arc(cr,center_x,(center_y-35),25,(0*d_math),(360*d_math))
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_stroke(cr)
cairo_set_line_width(cr,2)
cairo_arc(cr,center_x,(center_y-35),12,(0*d_math),(360*d_math))
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_stroke(cr)
month_days={31,28,31,30,31,30,31,31,30,31,30,31}
month_set=month_days[(month_number)]
for i=1,(month_set) do
month_day_marker=(-90*d_math)+(((360/month_set)*i)*d_math)
cairo_set_line_width(cr,1)
cairo_arc(cr,center_x,(center_y-35),25,month_day_marker,month_day_marker)
cairo_arc(cr,center_x,(center_y-35),20,month_day_marker,month_day_marker)
cairo_set_source_rgba(cr,.75,.75,.75,1)
cairo_stroke(cr)
end--for
cairo_set_source_rgba(cr,d_font_red,d_font_green,d_font_blue,d_font_alpha)
cairo_set_font_size (cr,8)
--######################################################################
-- mrpeacy code ########################################################
--######################################################################
for i=1,(month_set) do
	if i == 5 or i == 10 or i == 15 or i == 20 or i == 25 or i == month_set then
	x,y=pt(center_x,(center_y-35),18.5,((360/month_set)*i))
	text({y=y,x=x,t=i,hj="c",vj="m"})
	end
end--for
--######################################################################
-- mrpeacy code ########################################################
--######################################################################
cairo_stroke(cr)
day_indicator=(-90*d_math)+(((360/month_set)*day_number)*d_math)
cairo_set_line_width(cr,2)
cairo_move_to(cr,center_x,(center_y-35))
cairo_arc(cr,center_x,(center_y-35),20,day_indicator,day_indicator)
cairo_set_source_rgba(cr,.75,.75,.75,1)
cairo_stroke(cr)
--right year
cairo_set_line_width(cr,2)
cairo_arc(cr,(center_x+35),center_y,25,(0*d_math),(360*d_math))
cairo_arc_negative(cr,(center_x+35),center_y,12,(360*d_math),(0*d_math))
cairo_set_source_rgba(cr,bg_red,bg_green,bg_blue,bg_alpha)
cairo_fill(cr)
cairo_set_line_width(cr,2)
cairo_arc(cr,(center_x+35),center_y,25,(0*d_math),(360*d_math))
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_stroke(cr)
cairo_set_line_width(cr,2)
cairo_arc(cr,(center_x+35),center_y,12,(0*d_math),(360*d_math))
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_stroke(cr)
--when the year needs updated replace the start_year with the current year
start_year=13
cairo_set_font_size(cr,9)
cairo_set_source_rgba(cr,d_font_red,d_font_green,d_font_blue,d_font_alpha)
--######################################################################
-- mrpeacy code ########################################################
--######################################################################
for i=1,4 do
	x,y=pt((center_x+35),center_y,18.5,((360/4)*i))
	text({y=y,x=x,t=(start_year+(i-1)),hj="c",vj="m"})
end--for
--######################################################################
-- mrpeacy code ########################################################
--######################################################################
cairo_stroke(cr)
cairo_set_font_size (cr,d_font_size)
year_indicator=(-90*d_math)+(((360/4)*(year-(start_year-1)))*d_math)
cairo_set_line_width(cr,2)
cairo_move_to(cr,(center_x+35),center_y)
cairo_arc(cr,(center_x+35),center_y,20,year_indicator,year_indicator)
cairo_set_source_rgba(cr,.75,.75,.75,1)
cairo_stroke(cr)
--down month
cairo_set_line_width(cr,2)
cairo_arc(cr,center_x,(center_y+35),25,(0*d_math),(360*d_math))
cairo_arc_negative(cr,center_x,(center_y+35),12,(360*d_math),(0*d_math))
cairo_set_source_rgba(cr,bg_red,bg_green,bg_blue,bg_alpha)
cairo_fill(cr)
cairo_set_line_width(cr,2)
cairo_arc(cr,center_x,(center_y+35),25,(0*d_math),(360*d_math))
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_stroke(cr)
cairo_set_line_width(cr,2)
cairo_arc(cr,center_x,(center_y+35),12,(0*d_math),(360*d_math))
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_stroke(cr)
for i=1,12 do
month_indicator_marks=((360/12)*d_math)*i
cairo_set_line_width(cr,1)
cairo_arc(cr,center_x,(center_y+35),25,month_indicator_marks,month_indicator_marks)
cairo_arc(cr,center_x,(center_y+35),20,month_indicator_marks,month_indicator_marks)
cairo_set_source_rgba(cr,.75,.75,.75,1)
cairo_stroke(cr)
end--for
cairo_set_source_rgba(cr,d_font_red,d_font_green,d_font_blue,d_font_alpha)
--######################################################################
-- mrpeacy code ########################################################
--######################################################################
for i=1,12 do
	if i == 3 or i == 6 or i == 9 or i == 12 then
	x,y=pt(center_x,(center_y+35),18,((360/12)*i))
	text({y=y,x=x,t=i,hj="c",vj="m"})
	end
end--for
--######################################################################
-- mrpeacy code ########################################################
--######################################################################
cairo_stroke(cr)
month_indicator=(-90*d_math)+(((360/12)*month_number)*d_math)
cairo_set_line_width(cr,2)
cairo_move_to(cr,center_x,(center_y+35))
cairo_arc(cr,center_x,(center_y+35),20,month_indicator,month_indicator)
cairo_set_source_rgba(cr,.75,.75,.75,1)
cairo_stroke(cr)
end--chrono
--######################################################################
-- Face one ############################################################
--######################################################################
if clock_face == 1 then
--background
cairo_set_line_width(cr,5)
cairo_arc(cr,center_x,center_y,outer_radius,(-90*d_math),(270*d_math))
cairo_arc_negative(cr,center_x,center_y,(outer_radius-35),(270*d_math),(-90*d_math))
cairo_set_source_rgba(cr,bg_red,bg_green,bg_blue,bg_alpha)
cairo_fill_preserve(cr)
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_stroke(cr)
--seconds
second_radius1=outer_radius-2.5
second_radius2=second_radius1-10
for i=0,59 do
second_start=((i*(360/60))*d_math)
second_end=second_start+((360/60)*d_math)
second_start_math=(second_end-second_start)/2
second_start1=second_start-second_start_math-(90*d_math)
second_end1=second_start1+((360/60)*d_math)
cairo_set_line_width(cr,d_line_width)
cairo_arc(cr,center_x,center_y,second_radius1,second_start1,second_end1)
cairo_arc_negative(cr,center_x,center_y,second_radius2,second_end1,second_start1)
cairo_close_path(cr)
if lights == 1 then
if i == second then
cairo_set_source_rgba(cr,lights_red,lights_green,lights_blue,lights_alpha)
cairo_fill_preserve(cr)
end
end--lights
cairo_set_source_rgba(cr,.25,.25,.25,1)
cairo_stroke(cr)
end--for seconds end
--minutes
for i=0,59 do
minute_radius=second_radius2-10
minute_start=((i*(360/60))*d_math)
minute_end=minute_start+((360/60)*d_math)
minute_start_math=(minute_end-minute_start)/2
minute_start1=minute_start-minute_start_math-(90*d_math)
minute_end1=minute_start1+((360/60)*d_math)
cairo_set_line_width(cr,d_line_width)
cairo_arc(cr,center_x,center_y,second_radius2,minute_start1,minute_end1)
cairo_arc_negative(cr,center_x,center_y,minute_radius,minute_end1,minute_start1)
cairo_close_path(cr)
if lights == 1 then
if i == minute then
cairo_set_source_rgba(cr,lights_red,lights_green,lights_blue,lights_alpha)
cairo_fill_preserve(cr)
end
end--lights
cairo_set_source_rgba(cr,.25,.25,.25,1)
cairo_stroke(cr)
end--for minutes end
--hours
for i=i_start,i_end do
hour_radius=minute_radius-10
hour_start=((i*(360/hours))*d_math)
hour_end=hour_start+((360/hours)*d_math)
hour_start_math=((hour_end-hour_start)/2)
hour_start1=hour_start-hour_start_math-(90*d_math)
hour_end1=hour_start1+((360/hours)*d_math)
cairo_set_line_width(cr,d_line_width)
cairo_arc(cr,center_x,center_y,minute_radius,hour_start1,hour_end1)
cairo_arc_negative(cr,center_x,center_y,hour_radius,hour_end1,hour_start1)
cairo_close_path(cr)
if lights == 1 then
if i == hour then
cairo_set_source_rgba(cr,lights_red,lights_green,lights_blue,lights_alpha)
cairo_fill_preserve(cr)
end
end--lights
cairo_set_source_rgba(cr,.25,.25,.25,1)
cairo_stroke(cr)
end--for hours end
--######################################################################
-- mrpeacy code ########################################################
--######################################################################
if texts==1 then
cairo_set_source_rgba(cr,d_font_red,d_font_green,d_font_blue,d_font_alpha)
if hours==24 then
for i=0,23 do
	if i==0 or i==2 or i==4 or i==6 or i==8 or i==10 or i==12 or i==14 or i==16 or i==18 or i==20 or i==22 then
	x,y=pt(center_x,center_y,(hour_radius+5),((360/24)*i))
	text({y=y,x=x,t=i,hj="c",vj="m"})
	end
end--for
elseif hours==12 then
for i=1,12 do
	x,y=pt(center_x,center_y,(hour_radius+5),((360/12)*i))
	text({y=y,x=x,t=i,hj="c",vj="m"})
end--for
end--hours
if seconds==5 then
for i=0,59 do
	if i==0 or i==5 or i==10 or i==15 or i==20 or i==25 or i==30 or i==35 or i==40 or i==45 or i==50 or i==55 then
	x,y=pt(center_x,center_y,(second_radius2),((360/60)*i))
	text({y=y,x=x,t=i,hj="c",vj="m"})
	end
end--for
elseif seconds==10 then
for i=0,59 do
	if i==0 or i==10 or i==20 or i==30 or i==40 or i==50 then
	x,y=pt(center_x,center_y,(second_radius2),((360/60)*i))
	text({y=y,x=x,t=i,hj="c",vj="m"})
	end
end--for
elseif seconds==15 then
for i=0,59 do
	if i==0 or i==15 or i==30 or i==45 then
	x,y=pt(center_x,center_y,(second_radius2),((360/60)*i))
	text({y=y,x=x,t=i,hj="c",vj="m"})
	end
end--for
end--second
cairo_stroke(cr)
end--texts
--######################################################################
-- mrpeacy code end ####################################################
--######################################################################
end--clock face one
--######################################################################
-- Face two ############################################################
--######################################################################
if clock_face == 2 then
hour_markers_radius=outer_radius-20
second_markers_radius=outer_radius-10
--background
cairo_set_line_width(cr,1)
cairo_arc(cr,center_x,center_y,outer_radius,(-90*d_math),(270*d_math))
cairo_arc_negative(cr,center_x,center_y,(hour_markers_radius-13),(270*d_math),(-90*d_math))
cairo_set_source_rgba(cr,bg_red,bg_green,bg_blue,bg_alpha)
cairo_fill(cr)
cairo_set_line_width(cr,5)
cairo_arc(cr,center_x,center_y,outer_radius,(-90*d_math),(270*d_math))
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_stroke(cr)
cairo_set_line_width(cr,2)
cairo_arc(cr,center_x,center_y,(hour_markers_radius-13),(-90*d_math),(270*d_math))
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_stroke(cr)
--######################################################################
-- mrpeacy code ########################################################
--######################################################################
if texts==1 then
cairo_set_source_rgba(cr,d_font_red,d_font_green,d_font_blue,d_font_alpha)
if hours==24 then
for i=0,23 do
	if i==0 or i==2 or i==4 or i==6 or i==8 or i==10 or i==12 or i==14 or i==16 or i==18 or i==20 or i==22 then
	x,y=pt(center_x,center_y,(hour_markers_radius-5),((360/24)*i))
	text({y=y,x=x,t=i,hj="c",vj="m"})
	end
end--for
elseif hours==12 then
for i=1,12 do
	x,y=pt(center_x,center_y,(hour_markers_radius-5),((360/12)*i))
	text({y=y,x=x,t=i,hj="c",vj="m"})
end--for
end--hours
if seconds==5 then
for i=0,59 do
	if i==0 or i==5 or i==10 or i==15 or i==20 or i==25 or i==30 or i==35 or i==40 or i==45 or i==50 or i==55 then
	x,y=pt(center_x,center_y,second_markers_radius,((360/60)*i))
	text({y=y,x=x,t=i,hj="c",vj="m"})
	end
end--for
elseif seconds==10 then
for i=0,59 do
	if i==0 or i==10 or i==20 or i==30 or i==40 or i==50 then
	x,y=pt(center_x,center_y,second_markers_radius,((360/60)*i))
	text({y=y,x=x,t=i,hj="c",vj="m"})
	end
end--for
elseif seconds==15 then
for i=0,59 do
	if i==0 or i==15 or i==30 or i==45 then
	x,y=pt(center_x,center_y,second_markers_radius,((360/60)*i))
	text({y=y,x=x,t=i,hj="c",vj="m"})
	end
end--for
end--seconds
cairo_stroke(cr)
end--texts
--######################################################################
-- mrpeacy code end ####################################################
--######################################################################
--second lights
sl_math1=(-90*d_math)+(((360/60)*second)*d_math)
if lights ==1 then
cairo_set_line_width(cr,3)
cairo_set_line_cap(cr,CAIRO_LINE_CAP_ROUND)
cairo_arc(cr,center_x,center_y,hour_markers_radius,(-90*d_math),sl_math1)
cairo_set_source_rgba(cr,lights_red,lights_green,lights_blue,lights_alpha)
cairo_stroke(cr)
end--lights
--minute
for i=1,60 do
second_markers_position=(-90*d_math)+((i*(360/60))*d_math)
cairo_set_line_width(cr,d_line_width)
cairo_set_line_cap(cr,CAIRO_LINE_CAP_BUTT)
cairo_arc(cr,center_x,center_y,outer_radius,second_markers_position,second_markers_position)
cairo_arc(cr,center_x,center_y,second_markers_radius,second_markers_position,second_markers_position)
cairo_set_source_rgba(cr,.75,.75,.75,1)
cairo_stroke(cr)
if lights == 1 then
if i == minute then
cairo_set_line_width(cr,6)
cairo_set_line_cap(cr,CAIRO_LINE_CAP_ROUND)
cairo_arc(cr,center_x,center_y,(outer_radius-2),second_markers_position,second_markers_position)
cairo_arc(cr,center_x,center_y,(second_markers_radius-5),second_markers_position,second_markers_position)
cairo_set_source_rgba(cr,lights_red,lights_green,lights_blue,lights_alpha)
cairo_stroke(cr)
end--minute
end--lights
end--for
--hour
for i=i_start,i_end do
hour_markers_position=(-90*d_math)+(i*(360/hours))*d_math
cairo_set_line_width(cr,d_line_width)
cairo_arc(cr,center_x,center_y,outer_radius,hour_markers_position,hour_markers_position)
cairo_arc(cr,center_x,center_y,hour_markers_radius,hour_markers_position,hour_markers_position)
cairo_set_source_rgba(cr,1,1,1,1)
cairo_stroke(cr)
if lights == 1 then
if i == hour then
cairo_set_line_width(cr,6)
cairo_set_line_cap(cr,CAIRO_LINE_CAP_ROUND)
cairo_arc(cr,center_x,center_y,(outer_radius-2),hour_markers_position,hour_markers_position)
cairo_arc(cr,center_x,center_y,(hour_markers_radius-5),hour_markers_position,hour_markers_position)
cairo_set_source_rgba(cr,lights_red,lights_green,lights_blue,lights_alpha)
cairo_stroke(cr)
end--hour
end--lights
end--for hour
--outer ring
cairo_set_line_width(cr,d_line_width)
cairo_arc(cr,center_x,center_y,outer_radius,(0*d_math),(360*d_math))
cairo_set_source_rgba(cr,1,1,1,1)
cairo_stroke(cr)
end--clock face two
--######################################################################
-- Hands ###############################################################
--######################################################################
if hands == 1 then
hour_hand_radius1=outer_radius-30
hour_hand_radius2=outer_radius-50
hour_position=(-90*d_math)+(((360/(hours*60*60))*((hour*60*60)+(minute*60)+second))*d_math)
cairo_set_line_width(cr,d_line_width)
cairo_arc(cr,center_x,center_y,10,(hour_position-(20*d_math)),(hour_position+(20*d_math)))
cairo_arc(cr,center_x,center_y,hour_hand_radius2,(hour_position+(5*d_math)),(hour_position+(5*d_math)))
cairo_arc(cr,center_x,center_y,hour_hand_radius1,hour_position,hour_position)
cairo_arc(cr,center_x,center_y,hour_hand_radius2,(hour_position-(5*d_math)),(hour_position-(5*d_math)))
cairo_close_path(cr)
cairo_set_source_rgba(cr,hands_ired,hands_igreen,hands_iblue,hands_alpha)
cairo_fill_preserve(cr)
cairo_set_source_rgba(cr,hands_red,hands_green,hands_blue,hands_alpha)
cairo_stroke(cr)
minute_hand_radius1=outer_radius-15
minute_hand_radius2=outer_radius-35
minute_position=(-90*d_math)+(((360/(60*60))*((minute*60)+second))*d_math)
cairo_set_line_width(cr,d_line_width)
cairo_arc(cr,center_x,center_y,10,(minute_position-(20*d_math)),(minute_position+(20*d_math)))
cairo_arc(cr,center_x,center_y,minute_hand_radius2,(minute_position+(5*d_math)),(minute_position+(5*d_math)))
cairo_arc(cr,center_x,center_y,minute_hand_radius1,minute_position,minute_position)
cairo_arc(cr,center_x,center_y,minute_hand_radius2,(minute_position-(5*d_math)),(minute_position-(5*d_math)))
cairo_close_path(cr)
cairo_set_source_rgba(cr,hands_ired,hands_igreen,hands_iblue,hands_alpha)
cairo_fill_preserve(cr)
cairo_set_source_rgba(cr,hands_red,hands_green,hands_blue,hands_alpha)
cairo_stroke(cr)
second_hand_radius=outer_radius-5
second_position=(-90*d_math)+(((360/60)*second)*d_math)
cairo_set_line_width(cr,2)
cairo_move_to(cr,center_x,center_y)
cairo_arc(cr,center_x,center_y,second_hand_radius,second_position,second_position)
cairo_set_source_rgba(cr,hands_red,hands_green,hands_blue,hands_alpha)
cairo_stroke(cr)
cairo_set_line_width(cr,1)
cairo_arc(cr,center_x,center_y,10,(0*d_math),(360*d_math))
cairo_set_source_rgba(cr,0,0,0,1)
cairo_fill_preserve(cr)
cairo_set_source_rgba(cr,.5,.5,.5,1)
cairo_stroke(cr)
--am & pm
if hours == 12 then
cairo_select_font_face (cr,d_font,d_font_slant,d_font_face);
cairo_set_font_size (cr,10)
cairo_set_source_rgba (cr,d_font_red,d_font_green,d_font_blue,d_font_alpha)
cairo_move_to (cr,(center_x-6.25),(center_y+3.25))
cairo_show_text (cr,ampm)
cairo_stroke (cr)
else
cairo_set_line_width(cr,2)
cairo_arc(cr,center_x,center_y,5,(0*d_math),(360*d_math))
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_fill(cr)
end--am & pm
end-- hands
--######################################################################
-- Digital #############################################################
--######################################################################
if digital == 1 then
ph=15
pw=40
p1x=center_x-pw
p1y=center_y-ph
p2x=center_x+pw
p2y=center_y+ph
pr=10
cairo_set_line_width(cr,2)
cairo_arc(cr,p1x,p1y,pr,(180*d_math),(270*d_math))
cairo_arc(cr,p2x,p1y,pr,(270*d_math),0)
cairo_arc(cr,p2x,p2y,pr,0,(90*d_math))
cairo_arc(cr,p1x,p2y,pr,(90*d_math),(180*d_math))
cairo_close_path(cr)
cairo_set_source_rgba(cr,bg_red,bg_green,bg_blue,bg_alpha)
cairo_fill_preserve(cr)
cairo_set_source_rgba(cr,br_red,br_green,br_blue,br_alpha)
cairo_stroke(cr)
for i=1,4 do
line=6
x1=center_x-40
y1=center_y-line
x2=center_x
y2=center_y-line
x3=center_x+25
y3=center_y-line
x4=center_x-45
y4=center_y+15
if hours == 12 then time_s=14 else time_s=18 end
s={16,d_font_size,d_font_size,time_s}
x={x1,x2,x3,x4}
y={y1,y2,y3,y4}
t={day,abbr_month,day_number,time_hms}
cairo_select_font_face (cr,d_font,d_font_slant,d_font_face);
cairo_set_font_size (cr,s[i])
cairo_set_source_rgba (cr,d_font_red,d_font_green,d_font_blue,d_font_alpha)
cairo_move_to (cr,x[i],y[i])
cairo_show_text (cr,t[i])
cairo_stroke (cr)
end--for
end--digital
--######################################################################
--######################################################################
--######################################################################
end-- if updates>5
cairo_destroy(cr)
cairo_surface_destroy(cs)
cr=nil
end-- end main function
--######################################################################
--Functions ############################################################
--######################################################################
function gear(position_x,position_y,radius,outer_teeth,inner_teeth,speed,speed_scale,direction,visibility)
gear_red=.75
gear_green=.75
gear_blue=.75
gear_line_width=4
gear_math=(math.pi/180)
gear_start=0
gear_end=360*gear_math
outer_teeth_radius=(radius)+gear_line_width
inner_radius=10
inner_teeth_radius=inner_radius+gear_line_width
--outer gear
cairo_set_line_width(cr,gear_line_width)
cairo_set_source_rgba(cr,gear_red,gear_green,gear_blue,(visibility))
cairo_arc(cr,(position_x),(position_y),(radius),gear_start,gear_end)
cairo_stroke(cr)
--outer gear teeth
for i=1,(outer_teeth) do
tooth_size=(360/(outer_teeth))/3
tooth_space=(360/(outer_teeth))
tooth_math=(((i-1)*tooth_space)+tooth_size)*gear_math
tooth_math2=(((360/(speed_scale))*(speed))*gear_math)
if (direction) == 1 then tooth=tooth_math+tooth_math2 else tooth=tooth_math-tooth_math2 end
teeth_s=tooth-((tooth_size/2)*gear_math)
teeth_e=tooth+((tooth_size/2)*gear_math)
cairo_set_line_width(cr,gear_line_width)
cairo_arc(cr,(position_x),(position_y),outer_teeth_radius,teeth_s,teeth_e)
cairo_set_source_rgba(cr,gear_red,gear_green,gear_blue,(visibility))
cairo_stroke(cr)
end--for loop
--inner gear
cairo_set_line_width(cr,gear_line_width)
cairo_set_source_rgba(cr,gear_red,gear_green,gear_blue,(visibility))
cairo_arc(cr,(position_x),(position_y),inner_radius,gear_start,gear_end)
cairo_stroke(cr)
--inner gear teeth
for i=1,(inner_teeth) do
tooth_size=(360/(inner_teeth))/3
tooth_space=(360/(inner_teeth))
tooth_math=(((i-1)*tooth_space)+tooth_size)*gear_math
tooth_math2=(((360/(speed_scale))*(speed))*gear_math)
if (direction) == 1 then tooth=tooth_math+tooth_math2 else tooth=tooth_math-tooth_math2 end
teeth_s=tooth-((tooth_size/2)*gear_math)
teeth_e=tooth+((tooth_size/2)*gear_math)
cairo_set_line_width(cr,gear_line_width)
cairo_arc(cr,(position_x),(position_y),inner_teeth_radius,teeth_s,teeth_e)
cairo_set_source_rgba(cr,gear_red,gear_green,gear_blue,(visibility))
cairo_stroke(cr)
end--for loop
end
--######################################################################
-- mrpeacy code ########################################################
--######################################################################
function pt(px,py,prad,pdeg)
local ppo=(math.pi/180)*pdeg
local px1=px+prad*(math.sin(ppo))
local py1=py-prad*(math.cos(ppo))
return px1,py1
end
function font(fontt)
local name=fontt.f	or default_font_name	or "mono"
local size=fontt.fs	or default_font_size	or 12
local face=fontt.ff	or default_font_face	or "n"
if face=="n" then
cairo_select_font_face(cr,name,CAIRO_FONT_SLANT_NORMAL,CAIRO_FONT_WEIGHT_NORMAL)
elseif face=="b" then
cairo_select_font_face(cr,name,CAIRO_FONT_SLANT_NORMAL,CAIRO_FONT_WEIGHT_BOLD)
elseif face=="i" then
cairo_select_font_face(cr,name,CAIRO_FONT_SLANT_ITALIC,CAIRO_FONT_WEIGHT_NORMAL)
elseif face=="bi" then
cairo_select_font_face(cr,name,CAIRO_FONT_SLANT_ITALIC,CAIRO_FONT_WEIGHT_BOLD)
end
cairo_set_font_size(cr,size)
end
function hexcolor(hexcolort)
local col=hexcolort.c	or default_hex_color	or 0xffffff
local a=hexcolort.a	or default_alpha	or 1
local r,g,b=((col/0x10000) % 0x100)/255,((col/0x100) % 0x100)/255,(col % 0x100)/255
cairo_set_source_rgba(cr,r,g,b,a)
end
function text(textt)
local x=textt.x 		or 100
local y=textt.y 		or 100
local t=textt.t 		or "set txt"
local hj=textt.hj 		or default_horizontal_justify		or "l"
local vj=textt.vj 		or default_vertical_justify		or "n"
local r=textt.r			or default_rotation			or 0
cairo_text_extents(cr,t,extents)
local wx=extents.x_advance
local wd=extents.width
local hy=extents.height
local bx=extents.x_bearing
local by=extents.y_bearing+hy
--hl-- l=left, c=center, r=right
if hj=="l" then
xa=x-bx
rad=0
elseif hj=="c" then
xa=x-((wx-bx)/2)-bx
rad=(wx-bx)/2
elseif hj=="r" then
xa=x-wx
rad=wx-bx
else
print ('hj not set correctly for text: '..t..' - "l", "c" or "r"')
xa=0
rad=0
end
--vj-- n=normal, nb=normal-ybearing, m=middle, mb=middle-ybearing, t=top
if vj=="n" then
ya=y
rad2=0
ry=by
elseif vj=="nb" then
ya=y-by
rad2=-by
ry=by
elseif vj=="m" then
ya=y+((hy-by)/2)
rad2=((hy-by)/2)
ry=((hy-by)/2)-by
elseif vj=="mb" then
ya=y+(hy/2)-by
rad2=(hy/2)-by
ry=((hy-by)/2)-by
elseif vj=="t" then
ya=y+hy-by
rad2=hy-by
ry=0+by
else
print ('vj not set correctly for text: '..t..' - "n", "nb", "m", "mb" or "t"')
ya=0
rad2=0
ry=0
end
--rotation
if r~=0 then
local x2,y2=pt(x,y,rad2,r-180)
local x1,y1=pt(x2,y2,rad,r-90)
cairo_save (cr)
cairo_translate (cr,x1,y1)
cairo_rotate(cr,(math.pi/180)*r)
cairo_show_text (cr,t)
cairo_stroke (cr)
cairo_restore (cr)
else
cairo_move_to (cr,xa,ya)
cairo_show_text (cr,t)
cairo_stroke (cr)
end--if ro
--set non local variables to nil
xa=nil;ya=nil;rad=nil;rad2=nil;ry=nil
end--function text #####################################################